#if !defined(lint) && defined(SCCSIDS)
static   char cmw_sccsid[] = "@(#)tfmd_main.c 2.4.1.1 95/01/19 SMI; SunOS CMW";
#endif

#include <sys/param.h>
#include <sys/wait.h>
#include <signal.h>

#define TFMD_SERVICE    "tfmd"

int	soc_debug;


main( argc, argv)
   int	argc;
   char	**argv;
{
  int	rc, ss, sd, pid;
  void reaper();

  tfm_check_tp( argv[0] );

   NoControl();
   signal( SIGCHLD, reaper);
   signal( SIGPIPE, SIG_IGN);

   pid = fork();
   if (pid < 0) {
      perror("tfmd: can't fork"); exit(1); }
   if (pid) { exit(0); }

   soc_debug = 1;
   ss = server_init( TFMD_SERVICE);
   if (ss<0) { exit(1); }

   for(;;) {
      sd = server_accept( ss);
      if (sd<0) { continue; }

      pid = fork();
      if (pid<0) { perror("fork"); continue; }

      if (pid != 0) {					/* parent */
         close(sd); 
      } else {						/* child */
         close(ss);
         do_request( sd);
         close(sd);
         exit(0);
      }
   }
}

void
reaper()
{
  union wait	status;
  
   while ((wait3(&status, WNOHANG|WUNTRACED, NULL)) > 0) { }
}

